//////////////////////////////////////////////////////////////////////
// Copyright (c) 1999 by Krzysztof Kuczek
// All rights reserved
//
// Distribute freely, but don't remove my name from source and documentation.
//
// No warrantee of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
// 
// Send bug reports, bug fixes, etc.
//
// email: qczek@student.uci.agh.edu.pl
// http://student.uci.agh.edu.pl/~qczek
//


#include "stdafx.h"
#include "PerfStats.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define MAX_VALUE_NAME              128

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPerfStats::CPerfStats()
{



}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

CPerfStats::~CPerfStats()
{

}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

BOOL CPerfStats::EnumCategories( void )
{

    HKEY hKey;
	HKEY hSubKey;

	DWORD  retCode;
	DWORD i,j;
	CHAR  KeyName[MAX_PATH];
	CHAR  ValueName[MAX_VALUE_NAME];
	CHAR  ValueData[MAX_PATH];
	DWORD dwcValueName; 
	DWORD dwcValueData;



	
	retCode = RegOpenKeyEx(
		HKEY_LOCAL_MACHINE,
		"System\\CurrentControlSet\\control\\PerfStats\\Enum",
		0,
		KEY_ENUMERATE_SUB_KEYS | KEY_EXECUTE | KEY_QUERY_VALUE,
        &hKey
		);

		
	i =0;
	while (retCode == ERROR_SUCCESS)
	{
		
		retCode = RegEnumKey(
			hKey,
			i,
			KeyName,
			MAX_PATH
			);

		if ( retCode == ERROR_SUCCESS )
		{
			strcpy(CategoryTab[i].KeyName, KeyName);
	

			retCode = RegOpenKeyEx(
			HKEY_LOCAL_MACHINE,
			CString("System\\CurrentControlSet\\control\\PerfStats\\Enum\\") + CString(KeyName) ,
			0,
			KEY_ENUMERATE_SUB_KEYS | KEY_EXECUTE | KEY_QUERY_VALUE,
			&hSubKey
			);

			j =0;
			while ( retCode == ERROR_SUCCESS )
			{
				
				dwcValueName = MAX_VALUE_NAME;
				dwcValueData = MAX_PATH;

				retCode = RegEnumValue(
					hSubKey,
					j,
					ValueName,
					&dwcValueName,
					NULL,
					NULL,
					(unsigned char *)ValueData,
					&dwcValueData
									
					);

				if (retCode == ERROR_SUCCESS)
				{
					if ( strcmp( ValueName, "Name") == 0 )
					{
						strcpy(CategoryTab[i].Name, ValueData);
					}

				}
			
				j++;
			}
		

			retCode = ERROR_SUCCESS;
		}

			if ( retCode == ERROR_SUCCESS )
			{
				OnHitCategory( &CategoryTab[i]);
			}
			i++;
	}
	

	

	return TRUE;

}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


BOOL CPerfStats::EnumElements( CATEGORY_STRUCT * pCategory )
{

    HKEY hKey;
	HKEY hSubKey;

	DWORD  retCode;
	DWORD i,j;
	CHAR  KeyName[MAX_PATH];
	CHAR  ValueName[MAX_VALUE_NAME];
	CHAR  ValueData[MAX_PATH];
	DWORD dwcValueName; 
	DWORD dwcValueData;

	
	retCode = RegOpenKeyEx(
		HKEY_LOCAL_MACHINE,
		CString("System\\CurrentControlSet\\control\\PerfStats\\Enum\\") + CString(pCategory->KeyName) ,
		0,
		KEY_ENUMERATE_SUB_KEYS | KEY_EXECUTE | KEY_QUERY_VALUE,
        &hKey
		);

		
	i =0;
	while (retCode == ERROR_SUCCESS)
	{
		
		retCode = RegEnumKey(
			hKey,
			i,
			KeyName,
			MAX_PATH
			);

		if ( retCode == ERROR_SUCCESS )
		{
			strcpy(ElementTab[i].KeyName, CString(pCategory->KeyName) + CString("\\") + CString(KeyName));
	
			retCode = RegOpenKeyEx(
			HKEY_LOCAL_MACHINE,
			CString("System\\CurrentControlSet\\control\\PerfStats\\Enum\\") + CString(pCategory->KeyName) + CString("\\") + CString(KeyName) ,
			0,
			KEY_ENUMERATE_SUB_KEYS | KEY_EXECUTE | KEY_QUERY_VALUE,
			&hSubKey
			);

			j =0;
			while ( retCode == ERROR_SUCCESS )
			{
				
				dwcValueName = MAX_VALUE_NAME;
				dwcValueData = MAX_PATH;

				retCode = RegEnumValue(
					hSubKey,
					j,
					ValueName,
					&dwcValueName,
					NULL,
					NULL,
					(unsigned char *)ValueData,
					&dwcValueData
									
					);

				if (retCode == ERROR_SUCCESS)
				{
					if ( strcmp( ValueName, "Name") == 0 )
					{
						strcpy(ElementTab[i].Name, ValueData);
					}

					if ( strcmp( ValueName, "Description") == 0 )
					{
						strcpy(ElementTab[i].Description, ValueData);
					}

					if ( strcmp( ValueName, "Differentiate") == 0 )
					{
						if ( strcmp(ValueData, "TRUE") == 0 )
						{
							ElementTab[i].Differentiate =  TRUE;
						}else
						{
							ElementTab[i].Differentiate =  FALSE;
						}
					}


				}
			
				j++;
			}
		

			retCode = ERROR_SUCCESS;
		}

			if ( retCode == ERROR_SUCCESS )
			{
				OnHitElement( &ElementTab[i]);
			}
			i++;
	}
	





	return TRUE;

}
	
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

DWORD CPerfStats::GetValue( ELEMENT_STRUCT * pElement)
{
    HKEY hKey;

	DWORD  retCode;
	DWORD i;
	CHAR  ValueName[MAX_VALUE_NAME];
	CHAR  ValueData[MAX_PATH];
	DWORD dwcValueName; 
	DWORD dwcValueData;
	DWORD retValue;

	
	retCode = RegOpenKeyEx(
		HKEY_DYN_DATA,
		CString("PerfStats\\StatData"),
		0,
		KEY_ENUMERATE_SUB_KEYS | KEY_EXECUTE | KEY_QUERY_VALUE,
        &hKey
		);


	i =0;
	while ( retCode == ERROR_SUCCESS )
	{
				
		dwcValueName = MAX_VALUE_NAME;
		dwcValueData = MAX_PATH;

		retCode = RegEnumValue(
					hKey,
					i,
					ValueName,
					&dwcValueName,
					NULL,
					NULL,
					(unsigned char *)ValueData,
					&dwcValueData
									
					);

		if (retCode == ERROR_SUCCESS)
		{
			if ( strcmp( ValueName, pElement->KeyName) == 0 )
				{
					retValue = *(DWORD *)ValueData;						
				}

		}

		i++;
	}


	return retValue;

}